/*パラレルポート接続 16桁2行液晶表示プログラム

表示内容：	Hello World!
		Debian GNU/Linux

最初に書いた日　2012.3.29 */

#include <stdio.h>
#include <sys/io.h>

/* ※パラレルポートのI/Oアドレスに合わせて書き換えてください */
#define parallel_out 0x2018

/* 液晶イニシャライズ関数 */
int lcd_init(void)
{
	/* 8bitモード DB4=1 DB5=1 DB6=0 DB7=0 R/W=0 RS=0 ,E=1にして1μsec待ってE=0にする */
	outb(0x03, parallel_out);	/* 0x03	= '00000011' */
	outb(0x043, parallel_out);	/* 0x043	= '01000011' */
	usleep(1);/* 1 = 1μsec */
	outb(0x03, parallel_out);	/* 0x03	= '00000011' */
	usleep(5000);/* 5000 = 5msec */

	/* もう一回同じ */
	outb(0x043, parallel_out);	/* 0x043	= '01000011' */
	usleep(1);/* 1 = 1μsec */
	outb(0x03, parallel_out);	/* 0x03	= '00000011' */
	usleep(100000);/* 100000 = 100msec */

	/* さらにもう一回同じ */
	outb(0x043, parallel_out);	/* 0x043	= '01000011' */
	usleep(1);/* 1 = 1μsec */
	outb(0x03, parallel_out);	/* 0x03	= '00000011' */
	usleep(100000);/* 100000 = 100msec */

	/* 4bitモード DB4=0 DB5=1 DB6=0 DB7=0 R/W=0 RS=0 ,E=1にして1μsec待ってE=0にする */
	outb(0x02, parallel_out);	/* 0x02	= '00000010' */
	outb(0x042, parallel_out);	/* 0x042	= '01000010' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02, parallel_out);	/* 0x02	= '00000010' */
	usleep(100);/* 100 = 100μsec */

	/* ファンクションセット DL=1(4bit) N=1(2行) F=1(5×10ドット) */
	/* 上位4bit */
	outb(0x042, parallel_out);	/* 0x042	= '01000010' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02, parallel_out);	/* 0x02	= '00000010' */
	usleep(100);/* 100 = 100μsec */	

	/* 下位4bit */
	outb(0x0c, parallel_out);	/* 0x0c	= '00001100' */	
	outb(0x04c, parallel_out);	/* 0x04c	= '01001100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x0c, parallel_out);	/* 0x0c	= '00001100' */
	usleep(100);/* 100 = 100μsec */

	/* 表示オン／オフコントロール D=1(表示オン) C=1(カーソルオン) B=1(ブリンクオン) */
	/* 上位4bit */
	outb(0x00, parallel_out);	/* 0x00	= '00000000' */
	outb(0x040, parallel_out);	/* 0x040	= '01000000' */
	usleep(1);/* 1 = 1μsec */
	outb(0x00, parallel_out);	/* 0x00	= '00000000' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x0f, parallel_out);	/* 0x0f	= '00001111' */
	outb(0x04f, parallel_out);	/* 0x04f	= '01001111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x0f, parallel_out);	/* 0x0f	= '00001111' */
	usleep(100);/* 100 = 100μsec */
}

/* 液晶画面に「Hello World」を表示する関数 */
int hello_world(void)
{
	/* H */
	/* 上位4bit */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	outb(0x064, parallel_out);	/* 0x064	= '01100100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x028, parallel_out);	/* 0x028	= '00101000' */
	outb(0x068, parallel_out);	/* 0x068	= '01101000' */
	usleep(1);/* 1 = 1μsec */
	outb(0x028, parallel_out);	/* 0x028	= '00101000' */
	usleep(100);/* 100 = 100μsec */

	/* e */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	outb(0x065, parallel_out);	/* 0x065	= '01100101' */
	usleep(1);/* 1 = 1μsec */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	usleep(100);/* 100 = 100μsec */

	/* l */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	outb(0x06c, parallel_out);	/* 0x06c	= '01101100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	usleep(100);/* 100 = 100μsec */

	/* l */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	outb(0x06c, parallel_out);	/* 0x06c	= '01101100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	usleep(100);/* 100 = 100μsec */

	/* o */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02f, parallel_out);	/* 0x02f	= '00101111' */
	outb(0x06f, parallel_out);	/* 0x06f	= '01101111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02f, parallel_out);	/* 0x02f	= '00101111' */
	usleep(100);/* 100 = 100μsec */

	/*   (スペース) */
	/* 上位4bit */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	outb(0x061, parallel_out);	/* 0x061	= '01100001' */
	usleep(1);/* 1 = 1μsec */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x020, parallel_out);	/* 0x020	= '00100000' */
	outb(0x062, parallel_out);	/* 0x062	= '01100000' */
	usleep(1);/* 1 = 1μsec */
	outb(0x020, parallel_out);	/* 0x020	= '00100000' */
	usleep(100);/* 100 = 100μsec */

	/* W */
	/* 上位4bit */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	outb(0x065, parallel_out);	/* 0x065	= '01100101' */
	usleep(1);/* 1 = 1μsec */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	outb(0x067, parallel_out);	/* 0x067	= '01100111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	usleep(100);/* 100 = 100μsec */

	/* o */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02f, parallel_out);	/* 0x02f	= '00101111' */
	outb(0x06f, parallel_out);	/* 0x06f	= '01101111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02f, parallel_out);	/* 0x02f	= '00101111' */
	usleep(100);/* 100 = 100μsec */

	/* r */
	/* 上位4bit */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	outb(0x067, parallel_out);	/* 0x067	= '01100111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	outb(0x062, parallel_out);	/* 0x062	= '01100010' */
	usleep(1);/* 1 = 1μsec */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	usleep(100);/* 100 = 100μsec */

	/* l */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	outb(0x06c, parallel_out);	/* 0x06c	= '01101100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	usleep(100);/* 100 = 100μsec */

	/* d */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	outb(0x064, parallel_out);	/* 0x064	= '01100100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	usleep(100);/* 100 = 100μsec */

	/* ! */
	/* 上位4bit */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	outb(0x062, parallel_out);	/* 0x062	= '01100010' */
	usleep(1);/* 1 = 1μsec */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	outb(0x061, parallel_out);	/* 0x061	= '01100001' */
	usleep(1);/* 1 = 1μsec */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	usleep(100);/* 100 = 100μsec */
}

int cursor_move_line2_column1(void)
{
	/* カーソル2行目1桁目にセット */
	/* 上位4bit */
	outb(0x0c, parallel_out);	/* 0x0c	= '00001100' */
	outb(0x04c, parallel_out);	/* 0x04c	= '01001100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x0c, parallel_out);	/* 0x0c	= '00001100' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x00, parallel_out);	/* 0x00	= '00000000' */
	outb(0x040, parallel_out);	/* 0x040	= '01000000' */
	usleep(1);/* 1 = 1μsec */
	outb(0x00, parallel_out);	/* 0x00	= '00000000' */
	usleep(100);/* 100 = 100μsec */	
}

int debian(void)
{
	/* 液晶画面に 「Debian GNU/Linux」 を表示させる関数
	/* D */
	/* 上位4bit */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	outb(0x064, parallel_out);	/* 0x064	= '01100100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	outb(0x064, parallel_out);	/* 0x064	= '01100100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	usleep(100);/* 100 = 100μsec */

	/* e */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	outb(0x065, parallel_out);	/* 0x065	= '01100101' */
	usleep(1);/* 1 = 1μsec */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	usleep(100);/* 100 = 100μsec */

	/* b */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	outb(0x062, parallel_out);	/* 0x062	= '01100010' */
	usleep(1);/* 1 = 1μsec */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	usleep(100);/* 100 = 100μsec */

	/* i */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x029, parallel_out);	/* 0x029	= '00101001' */
	outb(0x069, parallel_out);	/* 0x069	= '01101001' */
	usleep(1);/* 1 = 1μsec */
	outb(0x029, parallel_out);	/* 0x029	= '00101001' */
	usleep(100);/* 100 = 100μsec */

	/* a */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	outb(0x061, parallel_out);	/* 0x061	= '01100001' */
	usleep(1);/* 1 = 1μsec */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	usleep(100);/* 100 = 100μsec */

	/* n */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02e, parallel_out);	/* 0x02e	= '00101110' */
	outb(0x06e, parallel_out);	/* 0x06e	= '01101110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02e, parallel_out);	/* 0x02e	= '00101110' */
	usleep(100);/* 100 = 100μsec */

	/*   (スペース) */
	/* 上位4bit */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	outb(0x061, parallel_out);	/* 0x061	= '01100001' */
	usleep(1);/* 1 = 1μsec */
	outb(0x021, parallel_out);	/* 0x021	= '00100001' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x020, parallel_out);	/* 0x020	= '00100000' */
	outb(0x062, parallel_out);	/* 0x062	= '01100000' */
	usleep(1);/* 1 = 1μsec */
	outb(0x020, parallel_out);	/* 0x020	= '00100000' */
	usleep(100);/* 100 = 100μsec */

	/* G */
	/* 上位4bit */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	outb(0x064, parallel_out);	/* 0x064	= '01100100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	outb(0x067, parallel_out);	/* 0x067	= '01100111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	usleep(100);/* 100 = 100μsec */

	/* N */
	/* 上位4bit */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	outb(0x064, parallel_out);	/* 0x064	= '01100100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02e, parallel_out);	/* 0x02e	= '00101110' */
	outb(0x06e, parallel_out);	/* 0x06e	= '01101110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02e, parallel_out);	/* 0x02e	= '00101110' */
	usleep(100);/* 100 = 100μsec */

	/* U */
	/* 上位4bit */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	outb(0x065, parallel_out);	/* 0x065	= '01100101' */
	usleep(1);/* 1 = 1μsec */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	outb(0x065, parallel_out);	/* 0x065	= '01100101' */
	usleep(1);/* 1 = 1μsec */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	usleep(100);/* 100 = 100μsec */

	/* / */
	/* 上位4bit */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	outb(0x062, parallel_out);	/* 0x062	= '01100010' */
	usleep(1);/* 1 = 1μsec */
	outb(0x022, parallel_out);	/* 0x022	= '00100010' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02f, parallel_out);	/* 0x02f	= '00101111' */
	outb(0x06f, parallel_out);	/* 0x06f	= '01101111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02f, parallel_out);	/* 0x02f	= '00101111' */
	usleep(100);/* 100 = 100μsec */

	/* L */
	/* 上位4bit */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	outb(0x064, parallel_out);	/* 0x064	= '01100100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x024, parallel_out);	/* 0x024	= '00100100' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	outb(0x06c, parallel_out);	/* 0x06c	= '01101100' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02c, parallel_out);	/* 0x02c	= '00101100' */
	usleep(100);/* 100 = 100μsec */

	/* i */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x029, parallel_out);	/* 0x029	= '00101001' */
	outb(0x069, parallel_out);	/* 0x069	= '01101001' */
	usleep(1);/* 1 = 1μsec */
	outb(0x029, parallel_out);	/* 0x029	= '00101001' */
	usleep(100);/* 100 = 100μsec */

	/* n */
	/* 上位4bit */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	outb(0x066, parallel_out);	/* 0x066	= '01100110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x026, parallel_out);	/* 0x026	= '00100110' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x02e, parallel_out);	/* 0x02e	= '00101110' */
	outb(0x06e, parallel_out);	/* 0x06e	= '01101110' */
	usleep(1);/* 1 = 1μsec */
	outb(0x02e, parallel_out);	/* 0x02e	= '00101110' */
	usleep(100);/* 100 = 100μsec */

	/* u */
	/* 上位4bit */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	outb(0x067, parallel_out);	/* 0x067	= '01100111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	outb(0x065, parallel_out);	/* 0x065	= '01100101' */
	usleep(1);/* 1 = 1μsec */
	outb(0x025, parallel_out);	/* 0x025	= '00100101' */
	usleep(100);/* 100 = 100μsec */

	/* x */
	/* 上位4bit */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	outb(0x067, parallel_out);	/* 0x067	= '01100111' */
	usleep(1);/* 1 = 1μsec */
	outb(0x027, parallel_out);	/* 0x027	= '00100111' */
	usleep(100);/* 100 = 100μsec */

	/* 下位4bit */
	outb(0x028, parallel_out);	/* 0x028	= '00101000' */
	outb(0x068, parallel_out);	/* 0x068	= '01101000' */
	usleep(1);/* 1 = 1μsec */
	outb(0x028, parallel_out);	/* 0x028	= '00101000' */
	usleep(100);/* 100 = 100μsec */
}

/* メイン関数 */
int main(void)
{
	/* I/O ports 宣言 */
	ioperm(parallel_out, 8, 1);

	/* 端末画面メッセージ等 */
	system("clear");
	printf("\n＊16行2桁液晶表示プログラム＊\n表示パターン：Hello World!\n");
	printf("　　　　　　　Debian GNU/Linux\n\n");
	system("aplay -q start.wav");

	/* LCDイニシャライズ関数呼び出し */
	lcd_init();

	/* 液晶画面表示関数呼び出し */
	/* "Hello World!" 表示 */
	hello_world();

	/* カーソル位置2行目1桁目へ移動 */
	cursor_move_line2_column1();

	/* "Debian GNU/Linux" 表示 */
	debian();

	/* 端末画面メッセージ等 */
	printf("表示完了！\n\n");
	system("aplay -q end.wav");

	/* プログラムを終了する前に全bitをLowにする */
	outb(0x00, parallel_out);	/* 0x00	= '00000000' */

	return 0;
}

